; Timer (IRQ0) handler
;
; Copyright (C) 1999 Thomas Novelli
;	Retro is distributed under the terms of the GNU LGPL, version 2 or
;	greater. (For the text of the license, see the file COPYING.LIB)
;
; Progress:
;	3/23/99 Need the IRQ0 timer for multitasking. Tested at different
;		speeds -- works fine. Also useful for measuring performance.
;

extern	_patch_int
%include "boot.mac"
%include "macros.mac"

extern	_putc

; Ports:
%define	ch0	0x40	;Channel 0: 18.2 Hz clock (IRQ 0)	(r/w)
%define	ch1	0x41	;Channel 1: DRAM refresh		(r/w)
%define	ch2	0x42	;Channel 2: Speaker			(r/w)
%define	ctl	0x43	;PIT control port			(write)
%define	ch3	0x44	;Channel 3: (PS/2 only) NMI generator	(r/w)

; Crystal: 1,193,181 Hz

	SECTION .text

init:
%if 0
	mov	al, 00110000b	;Counter 0, LSB-then-MSB, mode 0, binary
	out	ctl, al
;	mov	ax, 1193	;1 millisecond interval
	mov	ax, 0xF000
	out	ch0, al
	mov	al, ah
	out	ch0, al
%endif

	patch_int	0x20, irq0_handler
	ret


irq0_handler:
	;Do something...?
	; IRQ0 will be for the scheduler
	push	eax
putc '.'
	irqack	0
	pop	eax
	sti
	iretd


	global f	;FAster!
f:
	push	eax
	mov	ax, 0x1000
	out	ch0, al
	mov	al, ah
	out	ch0, al
	pop	eax
	ret


	global test_timer
test_timer:
	push	eax
	mov	al, 11111100b	;Unmask timer IRQ
	out	0x21, al
	pop	eax
	ret


timer_wait:
;
; Parameters:
;	# of ticks to wait
;
	ret



%if 0
test_irq0_handler:
	inc	dword [counter]
	print_hex [counter]
	call	cr
	dec	byte [0x451]		;Y-- (don't scroll)

	irqack	0
	sti
	iretd


	SECTION .data

counter:	dd	0
%endif
