
;Numeric output
; We need: <# SIGN # #S HOLD #>


TYPE    ;( c-addr u -- , display a text string u chars long )
        push    eax
        push    ebx
        push    ecx
        push    esi

        mov     ah, 0x0E        ;BIOS service 100E (TTY char output)
        mov     bx, 0           ;Set video page & text color to 0
        upop    ecx
        upop    esi
.l1
        cmp     [esi], byte 0
        je      .end
        mov     al, [esi]       ;AL = Char to print
        int     10h
        inc     esi
        loop    .l1
.end
        pop     esi
        pop     ecx
        pop     ebx
        pop     eax
        ret
end TYPE



EMIT    ;( char -- , display a single character )
        push    eax
        push    ebx

        upop    eax
        mov     ah, 0x0E
        mov     bx, 0
        int     0x10

        pop     ebx
        pop     eax
        ret
end EMIT



CR
        upsh    cell 13
        call    EMIT
        upsh    cell 10
        jmp     EMIT
end CR



SPACE
        upsh    cell ' '
        jmp     EMIT
end SPACE



PRINT   ;( n -- , Display a number in free-field format )
        push    eax
        push    ebx
        push    ecx
        push    edx

        upop    eax
        mov     ebx, [_BASE]
        xor     ecx, ecx        ;Counter = 0

        cmp     eax, 0          ;Zero, Positive, or Negative?
        jz      .zero
        jg      .build

        upsh    cell '-'
        call    EMIT
        neg     eax

.build
        xor     edx, edx
        div     ebx
        cmp     eax, 0
        jnz     .nz
        cmp     edx, 0
        jz      .print
.nz
        push    edx
        inc     ecx
        jmp     .build

.zero
        push    cell 0
        inc     ecx

.print
        pop     eax
        add     al, '0'
        cmp     al, '9'
        jbe     .emit
        add     al, 7
.emit
        upsh    eax
        call    EMIT
        loop    .print

        call    SPACE
        pop     edx
        pop     ecx
        pop     ebx
        pop     eax
        ret
end PRINT



PRINT_STRING
        upsh    cell '"'
        call    PARSE

        cmp     [_STATE], cell 0
        jz      .interpret

        call    S_QUOTE.skip_parse      ;Compile
        upsh    cell TYPE
        call    COMPILE
        jmp     .end

.interpret
        call    TYPE
.end
        ret
end PRINT_STRING



S_QUOTE ;( "ccc<quote>" -- c-addr u )
;Compilation: ( "ccc<quote>" -- )
;Run-time: ( -- c-addr u )
        upsh    cell '"'                ;Parse the string
        call    PARSE                   ;( inbuf u )
.skip_parse
        call    DUP
        call    ROT
        call    ROT
        call    HERE                    ;Buffer address = HERE 256 +
        upsh    cell 256
        call    PLUS
        call    SWAP                    ;( u inbuf c-addr u )
        call    _CMOVE                  ;Make a temporary copy

        call    HERE                    ;Buffer address = HERE 256 +
        upsh    cell 256
        call    PLUS
        call    SWAP                    ;( c-addr u )
        cmp     [_STATE], cell 0
        jz      .end

        call    SWAP                    ;Compile
        call    LITERAL
        call    LITERAL
.end
        ret
end S_QUOTE



PAD
        call    HERE
        upsh    cell 128
        call    PLUS
        ret
end PAD



BASE
        upsh    cell _BASE
        ret
end BASE

